# $Revision: 1.60 $, $Date: 2006/09/08 18:04:14 $
#
# Conditional build:
%bcond_with	php		# with PHP library
#
%define		php_version	4.0.6

Summary:	Throttleable lightweight HTTP server
Summary(pl):	Nieduy serwer HTTP do duych obcie
Name:		thttpd
Version:	2.25b
Release:	9
License:	BSD
Group:		Networking
Source0:	http://www.acme.com/software/thttpd/%{name}-%{version}.tar.gz
# Source0-md5:	a0e9cd87455d3a0ea11e5ea7e947adf6
Source1:	%{name}.init
Source2:	%{name}.conf
Source3:	%{name}-config.h
Patch0:		%{name}-includes.patch
Patch1:		additional-input-validation-httpd.c.diff
Patch2:		fix-buffer-overflow.diff
Patch3:		fix-insecure-tmp-creation-CVE-2005-3124.diff
Patch4:		thttpd-2.25b-fix-illegal-path-info.patch
Patch5:		thttpd-2.25b-glibc-2.10.patch
Patch6:		thttpd-2.25b-monolithic-timer.patch
Patch7:		thttpd-2.25b-respect-CFLAGS--dont-link-static.patch
Patch8:		thttpd-2.25b-use-Status-header.patch
Patch9:		thttpd-2.25b-use-X-Forwarded-For-header.patch
%if %{with php}
Source4:	http://www.php.net/distributions/php-%{php_version}.tar.gz
Patch10:	%{name}-php.patch
Patch11:	php-mysql-socket.patch
Patch12:	php-mail.patch
Patch13:	php-link-libs.patch
Patch14:	php-session-path.patch
Patch15:	php-am_ac_lt.patch
Patch16:	php-shared.patch
Patch17:	php-pldlogo.patch
Patch18:	php-ac250.patch
Patch19:	php-pearinstall.patch
Patch20:	%{name}-remove-php-patch.patch
%endif
URL:		http://www.acme.com/software/thttpd/
%if %{with php}
BuildRequires:	autoconf >= 1.4
BuildRequires:	automake >= 1.4d
BuildRequires:	bzip2-devel
BuildRequires:	db3-devel
BuildRequires:	gd-devel
BuildRequires:	libtool >= 1.4
BuildRequires:	mysql-devel
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(pre):	sh-utils
Requires:	htpasswd
Requires:	rc-scripts
Provides:	group(thttp)
Provides:	user(thttp)
Provides:	webserver
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		extensionsdir	%{_libdir}/php

%description
Thttpd is a very compact no-frills HTTP serving daemon that can handle
very high loads. While lacking many of the advanced features of
Apache, thttpd operates without forking and is extremely efficient in
memory use. Basic support for CGI scripts, authentication and SSI is
provided. Advanced features include the ability to throttle traffic.

%description -l pl
Thttpd jest kompaktowym serwerem HTTP, zdolnym obsugiwa bardzo
wysokie obcienia. Mimo i brakuje mu wielu zaawansowanych moliwoci
Apache, jest niezwykle wydajny jeli chodzi o wykorzystywanie pamici.
Dostarczane jest podstawowe wsparcie dla skryptw CGI,
uwierzytelniania, oraz SSI.

%package -n htpasswd-%{name}
Summary:	thttpd htpasswd utility
Summary(pl):	Narzdzie htpasswd z thttpd
Group:		Networking/Utilities
Provides:	htpasswd
Obsoletes:	htpasswd

%description -n htpasswd-%{name}
htpasswd is used to create and update the flat-files used to store
usernames and password for basic authentication of HTTP users. This
package contains htpasswd from thttpd; it supports only CRYPT
encryption algorithm.

%description -n htpasswd-%{name} -l pl
htpasswd suy do tworzenia i uaktualniania paskich plikw sucych
do przechowywania nazw uytkownikw i hase do uwierzytelnienia basic
uytkownikw HTTP. Ten pakiet zawiera htpasswd z thttpd; ta wersja
obsuguje wycznie hasa zaszyfrowane przez CRYPT.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1

%if %{with php}
%patch1 -p1
tar xzf %{SOURCE4}
cd php-%{php_version}
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
#%patch20 -p1
cp -f %{SOURCE3} ../config.h
%endif

%build
install %{_datadir}/automake/config.* .
CFLAGS="%{rpmcflags}"; export CFLAGS
%if %{with php}
cd php-%{php_version}
EXTENSION_DIR="%{extensionsdir}"; export EXTENSION_DIR
./buildconf
%{__libtoolize}
%{__aclocal}
%{__autoconf}

%configure \
	--with-thttpd=.. \
	--%{!?debug:dis}%{?debug:en}able-debug \
	--enable-bcmath \
	--enable-calendar \
	--enable-ctype \
	--enable-ftp \
	--enable-magic-quotes \
	--enable-shared \
	--enable-track-vars \
	--enable-safe-mode \
	--enable-trans-sid \
	--enable-sysvsem \
	--enable-sysvshm \
	--enable-shmop \
	--enable-session \
	--enable-exif \
	--with-db3 \
	--with-regex=php \
	--with-gettext \
	--with-zlib \
	--with-gd \
	--with-bz2 \
	--with-mysql=%{_prefix} \
	--with-mysql-sock=/var/lib/mysql/mysql.sock
#	--with-pear=%{peardir} \

%{__make}
# this install adds special options to thttpd Makefile.in
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
cd ..
%endif
# unfortunately this configure _must_ be here
%configure2_13
%{__make} \
	CCOPT="%{rpmcflags}" \
	prefix=%{_prefix} \
	BINDIR=%{_sbindir} \
	MANDIR=%{_mandir} \
	WEBDIR=/home/services/%{name}/html \
	CGIBINDIR=/home/services/%{name}/cgi-bin \
	WEBGROUP=%{name}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/home/services/%{name}/{cgi-bin,html},%{_sbindir},%{_bindir}} \
	$RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_sysconfdir},%{_mandir}/man{1,8}}

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}
install thttpd $RPM_BUILD_ROOT%{_sbindir}
install extras/{makeweb,syslogtocern} $RPM_BUILD_ROOT%{_sbindir}
install cgi-bin/printenv $RPM_BUILD_ROOT/home/services/%{name}/cgi-bin
install cgi-src/{phf,redirect,ssi} $RPM_BUILD_ROOT/home/services/%{name}/cgi-bin
install cgi-src/{redirect.8,ssi.8} $RPM_BUILD_ROOT%{_mandir}/man8
install extras/makeweb.1 $RPM_BUILD_ROOT%{_mandir}/man1
install extras/syslogtocern.8 $RPM_BUILD_ROOT%{_mandir}/man8
install thttpd.8 $RPM_BUILD_ROOT%{_mandir}/man8

# htpasswd
install extras/htpasswd $RPM_BUILD_ROOT%{_bindir}
ln -sf %{_bindir}/htpasswd $RPM_BUILD_ROOT%{_sbindir}
install extras/htpasswd.1 $RPM_BUILD_ROOT%{_mandir}/man1

%if %{with php}
cd php-%{php_version}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
cd ..
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 131 -r -f thttp
%useradd -u 117 -r -d /home/services/%{name} -s /bin/false -c "tHTTP User" -g thttp thttp

%post
/sbin/chkconfig --add %{name}
%service thttpd restart "%{name} daemon"

%preun
if [ "$1" = "0" ]; then
	%service thttpd stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove thttp
	%groupremove thttp
fi

%files
%defattr(644,root,root,755)
%doc README TODO
%if %{with php}
%doc php-%{php_version}/{LICENSE,NEWS}
%endif
%attr(2755,thttp,thttp) %{_sbindir}/makeweb
%attr(755,root,root) %{_sbindir}/syslogtocern
%attr(755,root,root) %{_sbindir}/%{name}
%attr(-,root,root) /home/services/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%config(noreplace) %{_sysconfdir}/%{name}.conf
%{_mandir}/man*/m*
%{_mandir}/man*/r*
%{_mandir}/man*/s*
%{_mandir}/man*/t*

%files -n htpasswd-%{name}
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/htpasswd
%{_sbindir}/htpasswd
%{_mandir}/man1/htpasswd.1*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: thttpd.spec,v $
Revision 1.60  2006/09/08 18:04:14  glen
- rel 8 (rebuild with fixed %useradd/%groupadd macros)

Revision 1.59  2006/04/14 16:25:31  glen
- rel 7

Revision 1.58  2006/03/13 23:14:32  glen
- use %service

Revision 1.57  2006/03/07 08:44:11  glen
- rel 6

Revision 1.56  2006/03/07 08:01:16  glen
- drop Provides: httpd

Revision 1.55  2005/08/11 09:46:18  radek
- bcond_with(out) is followed by one \t, then bcond's name.

Revision 1.54  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.53  2005/03/31 11:46:26  djrzulf
- rel 5,

Revision 1.52  2005/03/04 21:47:26  qboosh
- -htpasswd: replaced usage with real desc; pl

Revision 1.51  2005/03/04 19:35:30  djrzulf
- glen is a genious, simplify obsoletes section at htpasswd,
- Rel +0.1,
- ALL STBR AC-TEST

Revision 1.50  2005/03/04 14:30:45  djrzulf
- argh, obsoletes htpasswd-apache2 -> htpasswd-apache, thanks glen ;),

Revision 1.49  2005/03/04 10:31:55  djrzulf
- Rel +0.1,

Revision 1.48  2005/03/04 10:29:16  djrzulf
- added obsoletes,
- htpasswd from mini_httpd moved to separate package, Rel 3,

Revision 1.47  2005/03/04 10:06:46  djrzulf
- TODO updated,

Revision 1.46  2005/03/04 07:57:23  djrzulf
- htpasswd into seperate package, Rel 4, STBR AC-TEST,

Revision 1.45  2005/03/03 12:16:53  djrzulf
- added todo,

Revision 1.44  2004/10/29 13:36:57  paladine
- spelling fixes

Revision 1.43  2004/09/15 14:20:49  ankry
- %userremove/%groupremove macros support
- cleaning

Revision 1.42  2004/08/09 09:17:55  gotar
- noreplace for config file

Revision 1.41  2004/05/16 22:20:47  serek
- thttp could coexist with apache now.

Revision 1.40  2004/03/22 07:25:36  gotar
- moved to /home/services/httpd/,
- fixed passing CFLAGS,
- added /home/services/httpd/html/ directory to the package contents,
- %{_sysconfdir} can be != /etc/, install it explicitly,
- chown -R root:root /home/services/httpd - these files should not be owned
  by EUID of running thttpd process,
- release 2.

Revision 1.39  2004/03/14 12:38:25  gotar
- debug ready, cosmetics

Revision 1.38  2004/01/16 13:40:01  erjot
- up to 2.25b

Revision 1.37  2003/12/23 15:09:35  eothane
- updated to 2.25
- %bcond_with new_bcond_style

Revision 1.36  2003/11/03 00:01:07  arekm
- updated to 2.24

Revision 1.35  2003/09/30 17:47:26  serek
- htpasswd.1 confilcts with apache, so temporary commented - stupid typo

Revision 1.34  2003/09/30 17:45:48  serek
- htpasswd.1 confilcts with apache, so temporary commented

Revision 1.33  2003/08/26 15:03:36  qboosh
- no // in paths, other cosmetics

Revision 1.32  2003/05/28 13:02:15  malekith
- massive attack: source-md5

Revision 1.31  2003/05/25 06:27:20  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.30  2003/01/13 10:43:03  radek
- tweaked up description, adapterized

Revision 1.29  2002/10/09 13:14:49  kloczek
- use more macros, some cosmetics, added missing "rm -f missing" and use new %doc

Revision 1.28  2002/08/26 13:05:11  ankry
- fixed BCond description
- Conditional Sources on BCond (to enable build on their absence)

Revision 1.27  2002/08/18 09:48:27  kloczek
- cleanups.

Revision 1.26  2002/08/17 21:04:23  qboosh
- better messages in pre, more specific Requires

Revision 1.25  2002/06/23 20:32:36  kloczek
- perl -pi -e "s/^libtoolize --copy --force/\%\{__libtoolize\}/"

Revision 1.24  2002/05/21 23:14:49  kloczek
- perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
     s/^autoconf/\%\{__autoconf\}/"

Revision 1.23  2002/04/02 19:16:00  alchemyx
- changed priority of initscript so it is same as in apache
- release 4

Revision 1.22  2002/02/23 04:49:04  kloczek
- adapterized.

Revision 1.21  2002/02/22 23:29:48  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.20  2002/01/18 02:15:11  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.19  2001/12/21 14:08:11  bonkey
- release: 3
- php downgrade to 4.0.6
- some corrections in php build
- doesn't compile with php yet -- some php errors

Revision 1.18  2001/12/20 18:25:29  bonkey
- small cleanups for php building

Revision 1.17  2001/12/20 16:47:32  bonkey
- release: 2
- upgrade to 2.20c
- added conditional build with php (not ready yet, since php 4.1.0 is not
  ready, too)
- added more options to php and buildrequires
- some cleanups
- added restart and stop in %post/%preun scripts

Revision 1.16  2001/12/19 16:14:45  blues
- added URL for php

Revision 1.15  2001/12/19 10:41:30  qboosh
- adapterized, pl summary; NOTE: requires security update!

Revision 1.14  2001/09/10 18:20:36  blues
- Copy..... -> License

Revision 1.13  2001/07/26 05:42:25  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.11  2001/03/21 13:03:57  misiek
- now it links with php library

Revision 1.10  2001/03/21 11:54:07  misiek
- pre/post etc fixes

Revision 1.9  2001/03/21 11:08:35  misiek
- translations, changes in %prep

Revision 1.8  2001/03/19 20:11:58  alchemyx
- trying to play with php so it is still NFY

Revision 1.7  2001/03/18 22:16:25  alchemyx
- initfile and configfile heavily rewritten
- added webgroup entry
- changelog cut, but credits go to Jef Poskanzer <jef@acme.com> and
  Bennett Todd <bet@rahul.net> (authors of initial spec)
- still NFY

Revision 1.5  2001/03/18 20:54:45  alchemyx
- group and user httpd -> http

Revision 1.4  2001/03/18 20:38:24  alchemyx
- adding of group added
- changed adduser into useradd
- changed group and user names from httpd into http
- initfile rewritten
- user change in configfile
- NFY

Revision 1.3  2001/03/18 20:11:16  alchemyx
- installation done by hand
- some fixes in file section
- patch to compile properly
- initfile and config replaced with mine
- NFY

Revision 1.2  2001/03/17 22:19:32  alchemyx
- adapterized
- removed stupidity called PACKAGE_VERSION
